Scriptname FPV_OnHit extends ReferenceAlias

Actor Property PlayerRef Auto

ActorValue Property AFV_Gangbanged Auto
ActorValue Property AFV_NumberOfAggressors Auto
ActorValue Property AFV_TimesViolated Auto
ActorValue Property AFV_TimesViolatedCurrentScene Auto
ActorValue Property AFV_TimesParticipated Auto
ActorValue Property AFV_TimesParticipatedCurrentScene Auto
ActorValue Property HealthAV Auto
ActorValue Property Strength Auto
ActorValue Property Endurance Auto
ActorValue Property PerceptionCondition Auto
ActorValue Property LeftAttackCondition Auto
ActorValue Property RightAttackCondition Auto
ActorValue Property EnduranceCondition Auto
ActorValue Property RightMobilityCondition Auto
ActorValue Property LeftMobilityCondition Auto

Book Property AFV_ShockCollarNote Auto Const Mandatory

Faction Property SexFaction Auto		; used to control spectator behavior and identify AFV controlled actors

FPV_MCM_script Property FPV_MCM Auto

GlobalVariable Property AFV_SaveVersion Auto
GlobalVariable Property AFV_Global_Debug Auto
GlobalVariable Property AFV_Global_On Auto
GlobalVariable Property AFV_Global_PlayerAffected Auto
GlobalVariable Property AFV_Global_Health Auto
GlobalVariable Property AFV_Global_Cripple Auto
GlobalVariable Property AFV_Global_Chance Auto
GlobalVariable Property AFV_Global_Gender Auto
GlobalVariable Property AFV_Global_Essential Auto
GlobalVariable Property AFV_Global_Exhaustion Auto
GlobalVariable Property AFV_Global_Perversion Auto
GlobalVariable Property AFV_Global_Steal Auto
GlobalVariable Property AFV_Global_Health_A Auto
GlobalVariable Property AFV_Global_Cripple_A Auto
GlobalVariable Property AFV_Global_Gender_A Auto
GlobalVariable Property AFV_Global_Chance_A Auto
GlobalVariable Property AFV_Global_Unique_A Auto
GlobalVariable Property AFV_Global_Follower Auto
GlobalVariable Property AFV_Global_Gender_F Auto
GlobalVariable Property AFV_Global_Teleport Auto
GlobalVariable Property AFV_Global_Teleport_F Auto
GlobalVariable Property AFV_Global_Threesome Auto
GlobalVariable Property AFV_Global_Threesome_Mixed Auto
GlobalVariable Property AFV_Global_Duration Auto
GlobalVariable Property AFV_Global_Walk Auto
GlobalVariable Property AFV_Global_DD Auto
GlobalVariable property AFV_Global_Add_Actor_Chance auto
GlobalVariable Property AFV_Global_Companion_Dist Auto
GlobalVariable Property AFV_GlobaL_Force_Add_Round Auto
GlobalVariable Property AFV_Global_Use_Furniture Auto
GlobalVariable Property AFV_Global_Scan_Radius Auto
GlobalVariable Property AFV_Global_Furniture_Pref Auto
GlobalVariable Property AFV_Global_Pacification_Time Auto
GlobalVariable Property AFV_Global_Updating Auto
GlobalVariable Property AFV_IsMajorFunctionActive Auto
GlobalVariable Property AFV_Global_Use_Player_Loc Auto
GlobalVariable Property AFV_Global_BadEndChance Auto
GlobalVariable Property AFV_Global_Restraints Auto
GlobalVariable Property AFV_Global_RealHandcuffs Auto
GlobalVariable Property AFV_Global_RHCuffsChance Auto
GlobalVariable Property AFV_Global_RHHingedChance Auto
GlobalVariable Property AFV_Global_RHCollarChance Auto
GlobalVariable Property AFV_Global_RaiderPetChance Auto
GlobalVariable Property AFV_Global_Restraints_Strip Auto
GlobalVariable Property AFV_Global_RSEAbductionChance Auto
GlobalVariable Property AFV_Global_Outnumber Auto
GlobalVariable Property AFV_Global_ShockCollarCode Auto Const
GlobalVariable Property AFV_Global_POTC Auto
GlobalVariable Property AFV_Global_POTCChance Auto
GlobalVariable Property AFV_Global_Submission Auto
GlobalVariable Property AFV_Global_SelfEsteemRecovery Auto
GlobalVariable Property AFV_Global_DD_Max_Devices Auto
GlobalVariable Property AFV_Global_DDChance Auto
GlobalVariable Property AFV_Global_DD_Applyto Auto
GlobalVariable Property AFV_Global_ShowUI Auto

Idle Property Bleedout Auto
Idle Property IdleStop Auto
Idle Property RaiderSheath Auto
Idle Property RaiderSneakStop Auto

Keyword Property AAF_ActorBusy Auto
Keyword Property AnimFlavorHandsUp Auto
Keyword Property AnimArchetypePlayer Auto
Keyword Property LinkPowerArmor Auto
Keyword Property ActorTypeFeralGhoul Auto
Keyword[] Property FPV_AFA_SurrenderN Auto Const
Keyword[] Property FPV_AFA_SurrenderP Auto Const
Keyword[] Property FPV_AFA_AnimN Auto Const
Keyword[] Property FPV_AFA_AnimP Auto Const
Keyword[] Property ActorTypeKeywords Auto Const

ObjectReference Property SafePlace Auto

Quest Property FPV_Follower Auto
Quest Property FPV_Follower0 Auto
Quest Property FPV_Player Auto
Quest Property FPV_Retrieve Auto
Quest Property FPV_Spectator Auto
Quest Property FPV_Aggressor Auto
Quest Property FPV_Approach Auto
Quest Property FPV_BadEnd Auto
Quest Property FPV_RaiderPet Auto
Quest Property FPV_RSEAbduction Auto
Quest Property FPV_POTC Auto
Quest Property FPV_EnemyScan Auto

Form Property Pipboy Auto Const

Race[] Property AllowedRaces Auto
Race[] Property BasicRaces Auto
Race[] Property CompanionRaces Auto

RefCollectionAlias Property Companions Auto 		; for combat tracking - not during violations
RefCollectionAlias Property Enemies Auto			; enemies identified during surrender scan
RefCollectionAlias Property Followers Auto  		; holds followers during violations
RefCollectionAlias Property PacifiedEnemies Auto	; for modifying AI during outcome
RefCollectionAlias Property FleeingFollowers Auto	; for modifying AI during outcome

ReferenceAlias[] Property Victims Auto
ReferenceAlias Property Approacher Auto
ReferenceAlias Property Approached Auto
ReferenceAlias Property Robber Auto
ReferenceAlias Property Settler Auto
ReferenceAlias Property BadEndAggressor Auto
ReferenceAlias Property Captor Auto
ReferenceAlias Property ClosestEnemy Auto			; closest enemy identified during surrender scan

Scene Property AFV_Scene_Approach Auto

String[] Property DDColors Auto Const

Topic Property AFV_PlayerSurrenderTopic Auto Const
Topic Property AFV_PlayerGaspTopic Auto Const 
Topic Property AFV_PlayerRetreatTopic Auto Const

AAF:AAF_API AAF_API

Actor[] Ags_Valid

Bool combatInterrupt = false
Bool primaryOutcome = false
Bool surrenderActive = false
Bool victimWaiting = false
Bool CanDoGangbangs = false
Bool FeralGangbangs = false
Bool UseGodMode = false
Bool DebugOn = false
Bool FindLocked = false
Bool FirstTime = true
Bool ShowUI = false

Bool[] SavedNoBleedoutRecovery

CustomEvent FPV_Event_Surrender
CustomEvent Vin_Event_Suspend
CustomEvent Vin_Event_Resume
CustomEvent FPE_Entry

Float doCompanionTeleport = 0.0
Float bottom
Float bottomA
Float fEssentialDeathTimeSaved
Float MinPlayerHealthPercent
Float Submission = 0.0

FormList DD_FL_All
FormList DD_MaleModelItems

GlobalVariable FPA_Value_SelfEsteem
GlobalVariable FPA_Value_Spirit
GlobalVariable FPA_Value_Orientation
GlobalVariable FPA_Value_IsPlayerDesperateForSex
GlobalVariable FPA_Setting_SelfEsteemBaseRape

InputEnableLayer myLayer 

Int maxRapistE
Int curRapistE = 0
Int AggressorCount = 0
Int FollowerCount = 0
Int checking = 0
Int curRounds = 0
Int exRounds
Int PerRounds
Int currentS
Int interrupted
Int DDLoaded = 0
Int RHLoaded = 0
Int LLFPPluginVersion = 0
Int LLFPScriptVersion = 0
Int FirstNPC = 0

Int WeaponTimer = 1
Int ResetTimer = 2

Keyword RH_NoPackage
Keyword DD_kw_ItemType_Gag

Location savedLocation

ScriptObject DDlibs
ScriptObject RoggDDManager
ScriptObject RHScript
ScriptObject FPA_script

Import FPV_Logger

Function CheckUpdate()
	DebugOn = (AFV_Global_Debug.GetValue() == 1.0)
	Float isUpdate = AFV_Global_Updating.GetValue()

	If isUpdate > 0
		If (isUpdate == 2)
			AFVNotify(true,"AAF Violate: Older version found on save. Updating...")
		Else
			AFVNotify(true,"AAF Violate: Initializing...")
		EndIf

		AFV_IsMajorFunctionActive.setvalue(0)
		FPV_MCM.UpdateMCMSettings()
		
		LoadAAF(true)
		LoadDD(true)
		LoadRH(true)
		LoadFPA(true)
		CheckThirdPartyMods(true)
		
		If (isUpdate == 2)
			AFVNotify(true,"AAF Violate: Update complete")
		Else
			AFVNotify(true,"AAF Violate: Initialization complete")
		EndIf
		
		AFV_Global_Updating.setValue(0)
	Else
		LoadAAF(false)
		LoadDD(false)
		LoadRH(false)
		LoadFPA(false)
	EndIf
	
	MinPlayerHealthPercent = Game.GetGameSettingFloat("fPlayerHealthHeartbeatSlow")

	RegisterForRemoteEvent(PlayerRef, "OnPlayerLoadGame")
	RegisterForHitEvent(PlayerRef)
	
	CanDoGangBangs = Game.IsPluginInstalled("SavageCabbage_Animations.esp")
	FeralGangBangs = Game.IsPluginInstalled("AAF_Violate_Feral_Animations.esp")
	
	UseGodMode = (AFV_Global_Essential.GetValue() == 1.0)
	If (UseGodMode)
		PlayerRef.SetGhost(false)
	EndIf
EndFunction

Function Harmonize()
	Int i = 0
	
	While (i < Victims.length)
		Victims[i].clear()
		i += 1
	EndWhile

	FPV_Aggressor.Stop()
	FPV_Aggressor.Start()
	FPV_Follower.Stop()
	FPV_Follower.Start()
	FPV_Approach.Stop()
	FPV_Approach.Start()
	
	FollowerCount = Followers.GetCount()
	PlayerRef.StopCombatAlarm()
EndFunction

Function LoadAAF(Bool doNotify = true)
	GoToState("")
	AAF_API = Game.GetFormFromFile(0x00000F99, "AAF.esm") as AAF:AAF_API
	If !AAF_API
		AFVTrace(True, "AFV Report: AAF API not found.")
		AFVNotify(True,"AAF Violate Disabled: AAF API not found.")
		GoToState("Disabled")
		Utility.wait(0.1)
	Else
		AFVNotify(doNotify,"AAF Violate: AAF " + AAF_API.GetVersion() + " " + AAF_API.GetBuild() + " is installed")
		AFVTrace(DebugOn,"AFV report: AAF API version " + AAF_API.GetVersion() + " " + AAF_API.GetBuild())
		RegisterForCustomEvent(AAF_API, "OnAAFReady")
		
		LLFPPluginVersion = LL_FourPlay.GetLLFPPluginVersion() as Int
		LLFPScriptVersion = LL_FourPlay.GetLLFPScriptVersion() as Int
		AFVTrace(DebugOn,"AFV report: LLFP Plugin version " + LLFPPluginVersion + " Script version " + LLFPScriptVersion)
		If (!LLFPPluginVersion)
			AFVNotify(True, "AAF Violate Disabled: LLFP F4SE Plugin is not loaded.")
			GoToState("Disabled")
			Utility.wait(0.1)
		EndIf
	EndIf
EndFunction

Function LoadDD(Bool doNotify = true)
	If Game.IsPluginInstalled("Devious Devices.esm")
		Quest DDQuest = Game.GetFormFromFile(0x09004C50, "Devious Devices.esm") as Quest
		DDlibs = DDQuest.CastAs("DD:DD_Library")
		DD_FL_All = Game.getFormFromFile(0x0905E95B, "Devious Devices.esm") as FormList
		DD_MaleModelItems = Game.getFormFromFile(0x09044EBB, "Devious Devices.esm") as FormList
		DD_kw_ItemType_Gag = Game.GetFormFromFile(0x09015DE9, "Devious Devices.esm") as Keyword
		
		If DDlibs
			AFVTrace(DebugOn,"AFV report: Devious Devices is installed")
			AFVNotify(doNotify,"AAF Violate: Devious Devices is installed")
		EndIf
		
		If Game.IsPluginInstalled("Rogg DD Items Manager.esp")
			Quest RoggDDQuest = Game.GetFormFromFile(0x00004c50, "Rogg DD Items Manager.esp") as Quest
			RoggDDManager = RoggDDQuest.CastAs("Rogg:DDManager")
		Else
			RoggDDManager = None
		EndIf
		
		If RoggDDManager
			AFVTrace(DebugOn,"AFV report: Rogg DD Manager is installed")
			AFVNotify(doNotify,"AAF Violate: Rogg DD Manager is installed")
		EndIf
		Utility.Wait(0.1)
		DDLoaded = 2
	EndIf
EndFunction

Function LoadRH(Bool doNotify = true)
 	If Game.IsPluginInstalled("RealHandcuffs.esp")
		RH_NoPackage = Game.GetFormFromFile(0x000860, "RealHandcuffs.esp") as Keyword
		Quest RHQuest = Game.GetFormFromFile(0x00000F99, "RealHandcuffs.esp") as Quest
		RHScript = RHQuest.CastAs("RealHandcuffs:ThirdPartyApi")
		Int RHVersion = RHScript.CallFunction("ApiVersion", new Var[0]) as Int
		AFVTrace(DebugOn,"AFV Report: Real Handcuffs API Version " + RHVersion)
		
		Var[] RHArgs = New Var[2]
		RHArgs[0] = 0x0D9C37
		RHArgs[1] = "Fallout4.esm"
		Bool RHRetval = RHQuest.CastAs("RealHandcuffs:SoftDependencies").CallFunction("AddToBoundHandsGenericFurnitureList", RHArgs)
		AFVTrace(DebugOn,"AFV Report: add NPCPrisonerFloorSit to RH furniture list returned " + RHRetval)
		
		If (RHVersion < 4)
			AFVNotify(true,"AAF Violate: Real Handcuffs is out of date")
		Else
			AFVNotify(doNotify,"AAF Violate: Real Handcuffs is installed")
			RHLoaded = 2
		EndIf
	EndIf
EndFunction

Function LoadFPA(Bool doNotify = true)
	If Game.IsPluginInstalled("FPAttributes.esp")
		FPA_Value_Spirit = Game.GetFormFromFile(0x007A67, "FPAttributes.esp") as GlobalVariable
		FPA_Value_Orientation = Game.GetFormFromFile(0x000FAD, "FPAttributes.esp") as GlobalVariable
		FPA_Value_IsPlayerDesperateForSex = Game.GetFormFromFile(0x01A38D, "FPAttributes.esp") as GlobalVariable
		FPA_Value_Selfesteem = Game.GetFormFromFile(0x000FAC, "FPAttributes.esp") as GlobalVariable
		FPA_Setting_SelfEsteemBaseRape = Game.GetFormFromFile(0x000FA4, "FPAttributes.esp") as GlobalVariable
		Quest FPA_Main = Game.GetFormFromFile(0x00000F99, "FPAttributes.esp") as quest
		FPA_script = FPA_Main.CastAs("FPA:FPA_Main")

		AFVTrace(DebugOn,"AFV report: Sex Attributes is installed")
		AFVNotify(doNotify,"AAF Violate: Sex Attributes is installed")
	EndIf
EndFunction

Function CheckThirdPartyMods(Bool doNotify = true)
	If Game.IsPluginInstalled("AAF_BadEnd_Animations.esp")
		AFVNotify(doNotify,"AAF Violate: Bad End Animations is installed")
	EndIf
	If Game.IsPluginInstalled("AFVPurgatory.esp")
		AFVNotify(doNotify,"AAF Violate: Bad End Purgatory is installed")
	EndIf
	If (Game.isPluginInstalled("Raider Pet.esp"))
		AFVNotify(doNotify,"AAF Violate: Raider Pet is installed")
	EndIf
	If Game.IsPluginInstalled("RSE_II_CSA.esp")
		AFVNotify(doNotify,"AAF Violate: RSEII CSA is installed")
	Endif
	Int iCustomRaceCount = FPV_MCM.CustomRaces.Length
	If (iCustomRaceCount == 1)
		AFVNotify(doNotify,"AAF Violate: 1 custom race found")
	ElseIf (iCustomRaceCount > 1)
		AFVNotify(doNotify,"AAF Violate: " + iCustomRaceCount + " custom races found")
	EndIf
EndFunction

Float Function CheckDD()
	If DDLoaded == 2
			Return AFV_Global_DD.getValue()
	Else
		return 0
	EndIf
EndFunction

Float Function CheckRH()
	If RHLoaded == 2
			Return AFV_Global_RealHandcuffs.getValue()
	Else
		return 0
	EndIf
EndFunction

Function RandomDD(Actor akActor)
	If (RoggDDManager) && (akActor.GetLeveledActorBase().GetSex() == 1)
		AFVTrace(DebugOn,"AFV report: picking random DD items with Rogg DD Items Manager")
		Var formVar = RoggDDManager.CallFunction("PickRandomItemsRemote", new Var[0])
		form[] _forms
		If (formVar)
			_forms = Utility.VarToVarArray(formVar) as form[]
		EndIf
		var[] EdVar = new var[6]
		EdVar[0] = akActor
		EdVar[2] = none
		EdVar[3] = true
		EdVar[4] = none
		Int dieRoll = Utility.RandomInt(0,2)
		EdVar[5] = DDColors[dieRoll]
		
		Int maxDD = AFV_Global_DD_Max_Devices.GetValue() as Int
		If (maxDD > 0)
			While (_forms.Length > maxDD)
				Int x = Utility.RandomInt(0, _forms.Length - 1)
				_forms.Remove(x)
			EndWhile
		EndIf
		
		Int _i = _forms.Length
		While _i > 0
			_i = _i - 1
			EdVar[1] = _forms[_i] as armor
			Bool _result = DDLibs.CallFunction("EquipDevice", EdVar) as Bool
		EndWhile
	Else
		AFVTrace(DebugOn,"AFV report: picking random DD items")
		var[] EdVar = new var[5]
		EdVar[0] = akActor
		If akActor.GetLeveledActorBase().GetSex() == 1; Female
			EdVar[1] = DD_FL_All
		Else
			EdVar[1] = DD_MaleModelItems
		EndIf
		EdVar[2] = 5
		EdVar[3] = "none"
		EdVar[4] = false
		DDLibs.CallFunction("EquipRandomDevice", EdVar) as Bool
	EndIf
EndFunction

Function RemoveDDKeys(Actor akActor, Actor akTaker = None)
	; Chastity Key
	Key ddKeyItem =  Game.GetFormFromFile(0x09044E9F, "Devious Devices.esm") as Key
	akActor.RemoveItem(ddKeyItem, -1, true, akTaker)
	; Restraints Key
	ddKeyItem = Game.GetFormFromFile(0x09004C57, "Devious Devices.esm") as Key
	akActor.RemoveItem(ddKeyItem, -1, true, akTaker)
EndFunction

Function GiveDDKeys(Actor akActor)
	; Chastity Key
	Key ddKeyItem =  Game.GetFormFromFile(0x09044E9F, "Devious Devices.esm") as Key
	akActor.addItem(ddKeyItem)
	; Restraints Key
	ddKeyItem = Game.GetFormFromFile(0x09004C57, "Devious Devices.esm") as Key
	akActor.addItem(ddKeyItem)
EndFunction

ObjectReference Function RandomRH(Actor akActor)
	AFVTrace(DebugOn,"AFV report: applying RealHandcuffs")
	var[] rhArgs = new var[4]
	rhArgs[0] = akActor
	rhArgs[1] = AFV_Global_RHHingedChance.GetValueInt()
	rhArgs[2] = 0
	rhArgs[3] = rhScript.GetPropertyValue("FlagAddRemoveObjectsSilently")
	return rhScript.CallFunction("CreateRandomHandcuffsEquipOnActor", rhArgs) as ObjectReference
EndFunction

Function RemoveRHKeys(ObjectReference restraint, Actor akSource, Actor akDest = None)
	var[] rhArgs = new var[4]
	rhArgs[0] = restraint
	rhArgs[1] = akSource as ObjectReference
	rhArgs[2] = akDest as ObjectReference
	rhArgs[3] = rhScript.GetPropertyValue("FlagAddRemoveObjectsSilently")
	rhScript.CallFunction("RemoveKeysFromContainer", rhArgs)
EndFunction

Function GiveRHKeys(ObjectReference restraint, Actor akActor)
	var[] rhArgs = new var[4]
	rhArgs[0] = restraint
	rhArgs[1] = akActor as ObjectReference
	rhArgs[2] = 1 ; quantity
	rhArgs[3] = rhScript.GetPropertyValue("FlagAddRemoveObjectsSilently")
	rhScript.CallFunction("CreateKeysInContainer", rhArgs)
EndFunction

ObjectReference Function RandomRHShockCollar(Actor akActor)
	AFVTrace(DebugOn,"AFV report: applying Shock Collar")
	var[] rhArgs = new var[4]
	rhArgs[0] = akActor
	rhArgs[1] = 20
	rhArgs[2] = 20
	rhArgs[3] = rhScript.GetPropertyValue("FlagAddRemoveObjectsSilently")
	ObjectReference rhCollar = rhScript.CallFunction("CreateRandomShockCollarEquipOnActor", rhArgs) as ObjectReference

	If (rhCollar && akActor == PlayerRef)
		rhArgs = new var[1]
		rhArgs[0] = rhCollar
		Float Digits = rhScript.CallFunction("GetAccessCodeNumberOfDigits", rhArgs) as Float
		
		; to avoid leading-zero issues, 3-digit range is 100 - 999, 4-digit is 1000 - 9999)
		Int Code = Utility.RandomInt(Math.pow(10.0, Digits - 1.0) as Int, (Math.pow(10.0, Digits) - 1.0) as Int)
		
		rhArgs = new var[2]
		rhArgs[0] = rhCollar
		rhArgs[1] = Code
		rhScript.CallFunction("SetAccessCode", rhArgs)
		
		rhArgs[1] = 2
		rhScript.CallFunction("SetUnauthorizedAccessAction", rhArgs)
		
		AFVTrace(DebugOn,"AFV report: Code Digits " + Digits as Int + " digits, Min " + Math.pow(10.0, Digits - 1.0) as Int + " Max " + (Math.pow(10.0, Digits) - 1.0) as Int + " Code " + Code)
	EndIf

	return rhCollar
EndFunction

Function GiveRHShockCollarRemote(Actor akActor)
	var[] rhArgs = new var[3]
	rhArgs[0] = akActor as ObjectReference
	rhArgs[1] = rhScript.GetPropertyValue("FlagInitiallyDisabled")
	rhArgs[2] = 1 ; mod = powerful transmitter 
	ObjectReference myRemote = rhScript.CallFunction("CreateRemoteTriggerWithModsCloseTo", rhArgs) as ObjectReference
	
	If (myRemote != None)
		akActor.AddItem(myRemote, 1, True)
		akActor.EquipItem(myRemote.GetBaseObject(), False, True)
		AFVTrace(DebugOn,"AFV report: Remote added")
	Else
		AFVTrace(DebugOn,"AFV report: Remote not created")
	EndIf
EndFunction

Function GiveRHShockCollarNote(Actor akActor, ObjectReference myCollar)
	Var[] RHArgs = new Var[1]
	RHArgs[0] = myCollar
	Int AccessCode = rhScript.CallFunction("GetAccessCode", rhArgs) as Int
	AFV_Global_ShockCollarCode.SetValueInt(AccessCode)
	
	ObjectReference myNote = akActor.PlaceAtMe(AFV_ShockCollarNote, abForcePersist = false, abInitiallyDisabled = true, abDeleteWhenAble = false)
	myNote.AddTextReplacementData("CollarCode", AFV_Global_ShockCollarCode)
	myNote.AddTextReplacementData("CollarObject", myCollar.GetBaseObject())
	
	AFVTrace(DebugOn,"AFV report: Give Note, Access Code " + AccessCode)
	
	akActor.AddItem(myNote)
EndFunction

Function applyRestraints(actor akVictim, actor akAggressor)
	If (combatInterrupt)
		AFVTrace(DebugOn,"AFV report: applyRestraints scene ended by combat, aborting")
		return
	EndIf
	
	If (akAggressor != None && BasicRaces.Find(akAggressor.getRace()) > -1 && akAggressor.isDead() == false)
		AFVTrace(DebugOn,"AFV report: applyRestraints for " + akVictim.getLeveledActorBase().getName())
		
		Bool do_strip = AFV_Global_Restraints_Strip.GetValue() as Int != 0
		
		; Real Handcuffs
		If (CheckRH() && (Utility.RandomInt(0,99) < AFV_Global_RHCuffsChance.GetValue() as Int))
			If do_strip
				AAF_API.ApplyEquipmentSet(akVictim, "unEquip")
				do_strip = false
			Endif
			ObjectReference restraint = RandomRH(akVictim)
			If (restraint != None)
				If (akVictim == PlayerRef)
					GiveRHKeys(restraint, akAggressor)
				EndIf
				RemoveRHKeys(restraint, akVictim, akAggressor)
			EndIf
		EndIf
		
		; Real Handcuffs Shock Collar
		If (CheckRH() && (Utility.RandomInt(0,99) < AFV_Global_RHCollarChance.GetValue() as Int))
			If do_strip
				AAF_API.ApplyEquipmentSet(akVictim, "unEquip")
				do_strip = false
			Endif
			ObjectReference restraint = RandomRHShockCollar(akVictim)
			If (akVictim == PlayerRef && restraint != None)
				GiveRHShockCollarNote(akAggressor, restraint)
				GiveRHShockCollarRemote(akAggressor)
				PlayerRef.RemoveItem(AFV_ShockCollarNote, -1, true, None)
			EndIf
		EndIf
		
		; Plugs of the Commonwealth
		If (AFV_Global_POTC.GetValueInt() && Utility.RandomInt(0,99) < AFV_Global_POTCChance.GetValue() as Int)
			If do_strip
				AAF_API.ApplyEquipmentSet(akVictim, "unEquip")
				do_strip = false
			Endif
			(FPV_POTC as FPV_POTC_Script).ApplyPlug(akVictim)
		EndIf
		
		; Devious Devices
		Int ApplyTo = AFV_Global_DD_Applyto.GetValue() as Int
		If (CheckDD() && ((ApplyTo == 2) || (ApplyTo != (akVictim == PlayerRef))) && (Utility.RandomInt(0,99) < AFV_Global_DDChance.GetValue() as Int))
			If do_strip
				AAF_API.ApplyEquipmentSet(akVictim, "unEquip")
				do_strip = false
			Endif
			RandomDD(akVictim)
			If (akVictim == PlayerRef)
				GiveDDKeys(akAggressor)
			EndIf
			RemoveDDKeys(akVictim, akAggressor)
		EndIf
	Else
		AFVTrace(DebugOn,"AFV report: applyRestraints aggressor is dead, gone, or wrong race, aborting")
	EndIf
EndFunction

Function StartSex(Actor[] akActors, Bool akRape = True)
	Int i = 0
	While (i < akActors.length)
		AFVTrace(DebugOn,"AFV report: StartSex: akActors[" + i + "] is " + akActors[i].GetLeveledActorBase().GetName() + " [" + akActors[i].GetFormID() + "]")
	
		; put your guns away
		SheatheWeapon(akActors[i])
		
		; Stupid hack - isWeaponDrawn doesn't work on behemoths
		If akActors[i].HasKeyword(ActorTypeKeywords[4])
			akActors[i].UnequipItemSlot(33)
		EndIf
		
		i += 1
	EndWhile
		
	If interrupted == 0
		AAF:AAF_API:SceneSettings settings = AAF_API.GetSceneSettings()
		settings.duration = AFV_Global_Duration.getValue()
		
		If (AFV_Global_Use_Player_Loc.getValue() == 1.0)
			settings.locationObject = akActors[0]
		EndIf
		
		settings.preventFurniture = (AFV_Global_Use_Furniture.getValue() == 0.0)
		settings.scanRadius = AFV_Global_Scan_Radius.getValue() as Int
		settings.furniturePreference = AFV_Global_Furniture_Pref.getValue() as Int
		settings.isNPCControlled = true

		settings.usePackages = true
		settings.skipWalk = true

		If (akRape)
			settings.includeTags = "Aggressive"
		Else
			settings.includeTags = "Aggressive,Neutral"
		EndIf
		settings.excludeTags = "Spanking,Jackoff,Pose,Tease,Foreplay,Finish"
		
		If DD_kw_ItemType_Gag != none 
			If !akActors[0].WornHasKeyword(DD_kw_ItemType_Gag)
				settings.excludeTags += ",Gagged"
			Else
				settings.excludeTags += ",Blowjob"
			EndIf
		EndIf
		
		If (akActors[0] == PlayerRef && akRape)
			settings.meta = "AAF_Violate,PlayerRaped"
		Else
			settings.meta = "AAF_Violate"
		EndIf
		
		AAF_API.StartScene(akActors, settings)
		
		If akActors.length > 2
			akActors[0].ModValue(AFV_Gangbanged,1)
		Else
			ResetAV(akActors[0], AFV_Gangbanged)
		EndIf

		FPV_Spectator.Stop()
		FPV_Spectator.Start()
	EndIf
	Utility.wait(1.0)
EndFunction

Int Function FindRapistFor(Actor akVictim)
	Int found = 0
	If !akVictim
		AFVTrace(DebugOn,"AFV Report: there is invalid akVictim at FindRapistFor Function")
		interrupted = 1
	EndIf
	
	While (FindLocked)
		Utility.Wait(1.0)
	EndWhile
	FindLocked = true
	
	AFVTrace(DebugOn,"AFV report: start looking for rapists. max index is " + maxRapistE)

	While found == 0 && interrupted == 0 
		AFVTrace(DebugOn,"AFV report: FindRapistFor " + akVictim.GetLeveledActorBase().GetName() + ", cur " + curRapistE + " max " + maxRapistE)

		If curRapistE <= maxRapistE 
			Actor currentAg = Ags_Valid[curRapistE]
			curRapistE +=1

			If currentAg
				AFVTrace(DebugOn,"AFV report: cur rapist exists")
				If !currentAg.IsDead()
					AFVTrace(DebugOn,"AFV report: cur rapist is not dead")

					If !currentAg.HasKeyword(AAF_ActorBusy) && (currentAg.GetFactionRank(sexFaction) < 0) && found == 0
						AFVTrace(DebugOn,"AFV report: rapist found")
						found = 1
						victimWaiting = false
						currentAg.AddToFaction(SexFaction)
						akVictim.AddToFaction(SexFaction)
						UpdateSubmission()
						SetActorExpression(akVictim,1)

						If akVictim.GetDistance(currentAg) > 450
							currentAg.MoveTo(akVictim, 300 * Math.Sin(akVictim.GetAngleZ()), 300 * Math.Cos(akVictim.GetAngleZ()))
							currentAg.MoveToNearestNavmeshLocation()
							float zOffset = currentAg.GetHeadingAngle(PlayerRef)
							currentAg.SetAngle(currentAg.GetAngleX(), currentAg.GetAngleY(), currentAg.GetAngleZ() + zOffset)
						EndIf
						
						If (AFV_Global_Walk.GetValueInt() == 1 && akVictim == PlayerRef) || AFV_Global_Walk.GetValueInt() == 2
							If AFV_Scene_Approach.IsPlaying()
								AFV_Scene_Approach.Stop()
							EndIf
						
							Approacher.ForceRefTo(currentAg)
							Approached.ForceRefTo(akVictim)
																		
							AFV_Scene_Approach.Start()
							Int timeout = 0
							While AFV_Scene_Approach.IsPlaying() && timeout < 12
								Utility.Wait(1.0)
								timeout += 1
							EndWhile
							; clear aliases to avoid stuck packages on actors
							Approacher.Clear()
							Approached.Clear()
							AFVTrace(DebugOn,"AFV report: approach scene ended with timeout " + timeout)
						ElseIf (!FirstTime)
							Utility.Wait(5.0)
						EndIf
						
						FirstTime = false
						SexSceneChoosing(akVictim, currentAg)
					Else
						; If we are here then all rapists are busy with other victims.  So set a flag and wait.
						; With the flag set, the next victim to end animation will pause for 2 secs and we will get a round.
						victimWaiting = true
						AFVTrace(DebugOn,"AFV Report: rapist AAF Busy " + currentAg.HasKeyword(AAF_ActorBusy) + " SexFaction " + (currentAg.GetFactionRank(sexFaction) >= 0))
						Utility.wait(1.0)
					EndIf
				Else
					AFVTrace(DebugOn,"AFV Report: cur rapist is dead")
					curRounds += 1
				EndIf
			Else
				AFVTrace(DebugOn,"AFV Report: there is invalid currentAg at FindRapistFor Function")
				curRounds += 1				
			EndIf		
		Else
			Float fForceAddRound = AFV_Global_Force_Add_Round.GetValue()
			AFVTrace(DebugOn,"AFV report: all rapists gone and ForceAddRound is " + fForceAddRound)
			
			If curRounds < exRounds && fForceAddRound == 1.0
				curRapistE = 0
				AFVTrace(DebugOn,"AFV report: next circle started by " + akVictim.GetLeveledActorBase().GetName())
				Utility.Wait(0.5)
			Else
				If (akVictim == PlayerRef) || (AFV_Global_PlayerAffected.getValue() == 0)
					interrupted = 1 
					AFVTrace(DebugOn,"AFV report: all rapists gone. Primary actor " + akVictim.GetLeveledActorBase().GetName() + " starting outcome")
				Else
					found = -1
					AFVTrace(DebugOn,"AFV report: all rapists gone. Secondary actor " + akVictim.GetLeveledActorBase().GetName() + " waiting for outcome")
				EndIf
			EndIf
		EndIf
	EndWhile
	AFVTrace(DebugOn,"AFV report: FindRapistFor " + akVictim.GetLeveledActorBase().GetName() + " Function ended and interrupted is " + interrupted + " found is " + found)
	FindLocked = false
	return found
EndFunction

Function SexSceneChoosing(Actor akVictim, Actor currentAg)
	AFVTrace(DebugOn,"AFV SexSceneChoosing: curRapistE [" + curRapistE + "] maxRapistE [" + maxRapistE + "] CanDoGangbangs [" + CanDoGangbangs + "]")
	Actor[] akActors = new Actor[2]
	akActors[0] = akVictim
	akActors[1] = currentAg
	
	Race agRace = currentAG.getRace()
	If AFV_Global_Threesome.getValue() == 1 
		Int iLimit = 1
		If BasicRaces.Find(agRace) > -1
			If CanDoGangbangs == False || currentAG.HasKeyword(ActorTypeKeywords[1]) ; super mutants
				iLimit = 3
			Else
				iLimit = 5
			EndIf
		Else
			If FeralGangbangs == True && currentAG.HasKeyword(ActorTypeFeralGhoul)
				iLimit = 4
			EndIf
		EndIf
		
		While akActors.length < iLimit && curRapistE <= maxRapistE && Utility.RandomInt(0, 99) < AFV_Global_Add_Actor_Chance.GetValue() \
		&& !Ags_Valid[curRapistE].HasKeyword(AAF_ActorBusy) && (Ags_Valid[curRapistE].GetFactionRank(sexFaction) < 0) \
		&&  Ags_Valid[curRapistE].getRace() == agRace && !Ags_Valid[curRapistE].IsDead() \
		&& (AFV_Global_Threesome_Mixed.GetValue() == 1 || (currentAG.getLeveledActorBase().getSex() == 0 && Ags_Valid[curRapistE].getLeveledActorBase().getSex() == 0))
			akActors.Add(Ags_Valid[curRapistE])
			Ags_Valid[curRapistE].AddToFaction(SexFaction)
			Ags_Valid[curRapistE].MoveTo(akTarget=currentAg, abMatchRotation=True)
			curRapistE +=1
		EndWhile
	EndIf
	
	If Submission < 2
		StartSex(akActors,true)
	Else
		StartSex(akActors,false)
	EndIf
EndFunction

Function CheckRace(Bool bForceSurrender)
	If (checking == 0)
		checking = 1
		
		If (UseGodMode)
			PlayerRef.SetGhost(true)
		EndIf
		
		FPV_EnemyScan.Stop()
		FPV_EnemyScan.Start()
		
		AggressorCount = 0
		maxRapistE = -1; so that in the end, the number represents the final valid index
		
		ObjectReference Closest = ClosestEnemy.GetReference()
		If Closest != None
			Enemies.AddRef(Closest)
			
			AggressorCount = Enemies.GetCount()
			Int gendercheck = AFV_Global_Gender.getValueint()

			Ags_Valid = new Actor[40]
			Int currentE = 0
			While currentE < AggressorCount
				Actor currentCheck = Enemies.GetAt(currentE) as Actor
				If (AllowedRaces.Find(currentCheck.getRace()) > -1) && (gendercheck == 2 || currentCheck.GetLeveledActorBase().GetSex() == gendercheck) 
					maxRapistE += 1
					Ags_Valid[maxRapistE] = currentCheck
					RegisterForHitEvent(currentCheck)
				EndIf
				currentE += 1
			EndWhile
		EndIf
			
		int CompanionCount = Companions.GetCount() ; RefCollAlias on FPV_Follower0
		AFVTrace(DebugOn,"AFV report: combat targets [" + AggressorCount + "] rapists [" + (maxRapistE + 1) + "] companions [" + CompanionCount + "]")
		
		; no valid rapist or too few enemies
		If (maxRapistE < 0) || (bForceSurrender == False && AFV_Global_Outnumber.GetValueInt() == 1 && AggressorCount <= CompanionCount)
			RegisterForHitEvent(PlayerRef)
			
			If bForceSurrender == True
				If (AggressorCount)
					AFVNotify(true,"I cannot surrender to these enemies ...")
				Else
					AFVNotify(true,"There is no one here to surrender to...")
				EndIf
			EndIf
			If (UseGodMode)
				PlayerRef.SetGhost(false)
			EndIf
		Else
			Surrender(bForceSurrender)
		EndIf
		checking = 0
	Else
		AFVTrace(DebugOn,"AFV report: already checking")
	EndIf
EndFunction

State Disabled
	Function CheckRace(Bool bForceSurrender)
		If (!AAF_API)
			AFVNotify(true,"Cannot surrender due to AAF not found")
		Else
			AFVNotify(true,"Cannot surrender due to LLFP dll not loaded")
		EndIf
	EndFunction
EndState

Function Outcome(Int akOutcome = 0)
	If AFV_IsMajorFunctionActive.GetValue() == 0
		Int index = 0
		Float timerSecs = 10.0
		AFVTrace(DebugOn,"AFV report: outcome start")
		
		UnregisterForCustomEvent(AAF_API, "OnSceneInit")
		
		If Game.IsPluginInstalled("AAF_BadEnd_Animations.esp") && BasicRaces.Find(Ags_Valid[FirstNPC].getRace()) > -1 && \
		   !combatInterrupt && akOutcome == 1 && Utility.RandomInt(0,99) < AFV_Global_BadEndChance.getValue()
			FPV_Spectator.Stop()
			FPV_BadEnd.Start()
			BadEndAggressor.ForceRefTo(Ags_Valid[FirstNPC])
			If (FPV_BadEnd as FPV_BadEndScript).SetFatality()
				akOutcome = 0
			EndIf
			FPV_BadEnd.SetStage(10)
			
			While FPV_BadEnd.IsRunning()
				Utility.Wait(0.1)
			EndWhile
		EndIf

		curRounds = 0

		If akOutcome == 1; Passing out
			Game.FadeOutGame(True, True, 0.0, 2.0, True)
			Utility.Wait(2.0)
			If AFV_Global_Teleport.getValue() == 0
				PlayerRef.Say(AFV_PlayerGaspTopic)
			EndIf
			Game.FadeOutGame(False, True, 0.0, 2.0, False)
			
			Captor.ForceREFto(Ags_Valid[FirstNPC])
			FPV_RSEAbductionScript CSAScript = (FPV_RSEAbduction as FPV_RSEAbductionScript)
			If maxRapistE > 1 && FollowerCount == 0 && !combatInterrupt && (FPV_RaiderPet as FPV_RaiderPetScript).CheckLocationAndActors() && Utility.RandomInt(0,99) < AFV_Global_RaiderPetChance.getValue()
				Utility.Wait(2.0)
				FPV_RaiderPet.SetStage(10)
			ElseIf !Ags_Valid[FirstNPC].IsDead() && !combatInterrupt && CSAScript.LoadRSEAbductions() && CSAScript.ValidateCaptor(Ags_Valid[FirstNPC]) && Utility.RandomInt(0,99) < AFV_Global_RSEAbductionChance.getValue()
				Utility.Wait(2.0)
				CSAScript.AbductPlayer(Ags_Valid[FirstNPC])
			ElseIf AFV_Global_Teleport.getValue() == 1
				ObjectReference SettlerOR = Settler.getReference()
				ObjectReference TeleportTo			

				If SettlerOR
					TeleportTo = SettlerOR						
				Else
					TeleportTo = SafePlace
				EndIf
				
				savedLocation = PlayerRef.GetCurrentLocation()
				RegisterForPlayerTeleport()

				; position player right in front of the workshop workbench
				PlayerRef.moveTo(TeleportTo, -50 * Math.Sin(TeleportTo.GetAngleZ()), -50 * Math.Cos(TeleportTo.GetAngleZ()))
				PlayerRef.PlayIdle(IdleStop)
			Else
				Utility.Wait(2.0)
				AFVNotify(true,"I need to retreat!")
				PlayerRef.Say(AFV_PlayerRetreatTopic)
				timerSecs += AFV_Global_Pacification_Time.getValue()
				
				Int i = 0
				While (i < FollowerCount)
					Actor tActor = (Followers.getAt(i) as Actor)
					If (tActor)
						returnToPowerArmor(tActor)
						FleeingFollowers.addRef(tActor)
						Utility.Wait(0.1)
						tActor.evaluatePackage()
					EndIf
					i += 1
				EndWhile
			EndIf	
		Else
			timerSecs += AFV_Global_Pacification_Time.getValue()
		EndIf
		
		PacifiedEnemies.AddRefCollection(Enemies)
		
		StartTimer(timerSecs,ResetTimer)
		RegisterForMenuOpenCloseEvent("PipboyMenu")
		
		PlayerRef.ChangeAnimFlavor()
		PlayerRef.PlayIdle(IdleStop)
		
		; Prevent stuck anim archetypes
		If (checkDD() > 0)
			var[] DDVar = new var[1]
			DDVar[0] = PlayerRef
			DDLibs.CallFunction("RefreshBoundAnimations", DDVar)
		Else
			PlayerRef.ChangeAnimArchetype()
			PlayerRef.ChangeAnimArchetype(AnimArchetypePlayer)
		EndIf
		
		myLayer.EnablePlayerControls()
		myLayer.Delete()
		surrenderActive = false
	Else
		AFVTrace(DebugOn,"AFV report: tried to outcome, but major Function is ON")
		Utility.wait(3.0)
		checkForRapeEnd()
	EndIf
EndFunction

Function Interrupt()
	If (surrenderActive == False)
		AFVTrace(DebugOn,"AFV report: Interrupt function called")
		startTimer(0,ResetTimer)
	Else
		AFVTrace(True,"AFV report: Interrupt function called while surrender active, ignoring")
	EndIf
EndFunction

Function UpdateSubmission()
	If (FPA_Value_Spirit)
		If (FPA_Value_Spirit.GetValue() < 0.01) || (FPA_Value_IsPlayerDesperateForSex.GetValue() == 1.0) || (FPA_Value_Orientation.GetValue() < -30.0)
			Submission = 2.0
		ElseIf (FPA_Value_SelfEsteem.GetValue() + (FPA_Value_Orientation.GetValue() / 2.0) < 30.0)
			Submission = 1.0
		Else
			Submission = 0.0
		EndIf
	EndIf
	
	If (curRounds >= PerRounds)
		Submission = 2.0
	EndIf

	AFVTrace(DebugOn,"AFV report: Submission is " + Submission)
	AFV_Global_Submission.SetValue(Submission)
EndFunction

Int Function FindFirstNPC()
	Int i = 0
	While (i <= maxRapistE)
		If BasicRaces.Find(Ags_Valid[i].getRace()) > -1 && !Ags_Valid[i].IsDead()
			Return i
		Endif
		i += 1
	EndWhile
	Return 0
EndFunction

Function Surrender(Bool bForceSurrender)
	Bool bPlayerInterrupt = false
	Bool bCompanionInterrupt = false

	SendCustomEvent("Vin_Event_Suspend")
	myLayer = InputEnableLayer.Create()
	myLayer.DisablePlayerControls()
	
	fEssentialDeathTimeSaved = Game.GetGameSettingFloat("fEssentialDeathTime")
	Game.SetGameSettingFloat("fEssentialDeathTime", 1.0)
	
	AFV_IsMajorFunctionActive.SetValue(1)
	surrenderActive = true
	primaryOutcome = false
	combatInterrupt = false
	FindLocked = false
	FirstTime = true
	interrupted = 0
	curRounds = 0
	curRapistE = 0
	Harmonize()
	
	doCompanionTeleport = AFV_Global_Teleport_F.getValue()
	PerRounds = AFV_Global_Perversion.getValue() as Int
	ExRounds = AFV_Global_Exhaustion.getValue() as Int
	ShowUI = AFV_Global_ShowUI.GetValue() as Int
	
	ResetAV(PlayerRef, AFV_TimesViolatedCurrentScene)
	ResetAV(PlayerRef, AFV_Gangbanged)
	ResetAV(PlayerRef, AFV_NumberOfAggressors)
	PlayerRef.ModValue(AFV_NumberOfAggressors, maxRapistE + 1)
	
	Submission = 0
	
    If (UI.IsMenuOpen("PipboyMenu"))
        UI.CloseMenu("PipboyMenu")
        Utility.Wait(0.4)
    EndIf
	
	RestoreActorLimbs(PlayerRef)
	If (PlayerRef.GetValuePercentage(HealthAV) < MinPlayerHealthPercent)
		PlayerRef.RestoreValue(HealthAV, (MinPlayerHealthPercent - PlayerRef.GetValuePercentage(HealthAV)) * PlayerRef.GetBaseValue(HealthAV))
	EndIf
	
	PlayerRef.StopCombat()
	PlayerRef.StopCombatAlarm()
	
	; StartSneaking() is a toggle
	If PlayerRef.IsSneaking()
		PlayerRef.StartSneaking()
	EndIf
	
	SheatheWeapon(PlayerRef)
	StartTimer(2,WeaponTimer)
	
	;Debug.notification("I cannot continue fighting anymore ...")
	SetActorExpression(PlayerRef,1)
	PlayerRef.ChangeAnimFlavor(AnimFlavorHandsUp)
	Game.ForceThirdPerson()
	PlayerRef.Say(AFV_PlayerSurrenderTopic)
	Utility.Wait(1.0)
	
	; for aggression due to crime
	Faction AgCrimeFaction = Ags_Valid[0].GetCrimeFaction()
	If AgCrimeFaction != None && AgCrimeFaction.IsPlayerEnemy()
		AFVTrace(DebugOn, "AFV Report: clearing enemy state from " + AgCrimeFaction)
		AgCrimeFaction.SetPlayerEnemy(false)
	EndIf
	
	; surrender idle looks goofy in power armor and letting AAF manage it can cause issues.
	; SwitchToPowerArmor(none) seems to cause the ChangeAnimFlavor not to work. So we catch
	; the OnGetUp Event and set the animflavor there
	If PlayerRef.IsInPowerArmor()
		PlayerRef.SwitchToPowerArmor(None)
	EndIf
	
	; same for aggressors
	int index = 0
	While index <= maxRapistE
		If Ags_Valid[index].IsInPowerArmor()
			exitPowerArmor(Ags_Valid[index])
		EndIf
		index +=1
	EndWhile
	
	SavedNoBleedoutRecovery = new Bool[FollowerCount]
	
	index = 0
	Float fMaxDistance = AFV_Global_Companion_Dist.getValue()
	Int followerg = AFV_Global_Gender_F.getValue() as Int
	While (index < FollowerCount)
		Actor tActor = (Followers.GetAt(index) as Actor)
		If (tActor)
			AFVTrace(DebugOn,"AFV Report: Followers[" + index + "] is " + tActor.getLeveledActorBase().getName())
			
			SavedNoBleedoutRecovery[index] = tActor.GetNoBleedoutRecovery()
			tActor.SetNoBleedoutRecovery(false)
			
			SheatheWeapon(tActor)
			SetActorExpression(tActor,1)
			
			If tActor.IsInPowerArmor()
				exitPowerArmor(tActor)
			EndIf
			
			If (RH_NoPackage)
				tActor.AddKeyword(RH_NoPackage)
			EndIf
			
			Float DistanceToPlayer = PlayerRef.GetDistance(tActor)
			If (doCompanionTeleport) && (DistanceToPlayer > 500.0) && (DistanceToPlayer < fMaxDistance) && \
				(followerg == 2 || tActor.GetLeveledActorBase().GetSex() == followerg) && (CompanionRaces.Find(tActor.GetRace()) > -1)
				Float fDistance = Utility.RandomFloat(275.0,325.0)
				Float zAngle = Utility.RandomFloat(0.0,360.0)
				tActor.MoveTo(PlayerRef as ObjectReference, fDistance * Math.Sin(zAngle), fDistance * Math.Cos(zAngle))
				tActor.MoveToNearestNavmeshLocation()
			EndIf

		EndIf
		index += 1
	EndWhile
	
	; find the first aggressor who is a valid race for robbery etc.
	FirstNPC = FindFirstNPC()
	If Utility.RandomInt(0,99) < AFV_Global_Steal.getValueInt() && !FPV_Retrieve.IsRunning() && BasicRaces.Find(Ags_Valid[FirstNPC].getRace()) > -1 && !Ags_Valid[FirstNPC].IsDead()
		FPV_Retrieve.Stop()
		FPV_Retrieve.Start()
		Utility.wait(0.1)
		Robber.ForceRefTo(Ags_Valid[FirstNPC])
		FPV_Retrieve.setStage(0)
		Utility.Wait(4.0)
	Else
		Utility.Wait(2.0)
	EndIf
	
	; If we are configured to apply DD at beginning of scene, do it now for player
	If (AFV_Global_Restraints.GetValue() == 0)
		applyRestraints(PlayerRef, Ags_Valid[FirstNPC])
	EndIf
	
	RegisterForCustomEvent(AAF_API, "OnSceneInit")
	If (ShowUI)
		RegisterForCustomEvent(AAF_API, "OnAnimationStart")
	EndIf

	If (AAF_API.GetVersion() > 68)
		RegisterForCustomEvent(AAF_API, "OnSceneEnd")
	Else
		RegisterForCustomEvent(AAF_API, "OnAnimationStop")
	EndIf
		
	;rapist for player
	If AFV_Global_PlayerAffected.getValue() == 1 
		AFVTrace(DebugOn,"AFV report: Player can be target")
		
		FindRapistFor(PlayerRef)

		If interrupted == 1
			bPlayerInterrupt = true
		Else
			bPlayerInterrupt = false
		EndIf
	Else
		bPlayerInterrupt = true
	EndIf

	;rapist for companions	
	If AFV_Global_Follower.getValue() == 1 
		AFVTrace(DebugOn,"AFV report: Companions can be target")

		Int currentE = 0
		Int maxE = FollowerCount
		bCompanionInterrupt = true
		
		While currentE < maxE
			Actor currentF = Followers.GetAt(currentE) as Actor

			If currentF
				ResetAV(currentF,AFV_TimesViolatedCurrentScene)
				RestoreActorLimbs(currentF)
				
				Float fDistance = PlayerRef.GetDistance(currentF)
				AFVTrace(DebugOn,"AFV report: Distance to companion " + fDistance + " max distance is " + fMaxDistance)
				
				If fDistance < fMaxDistance
					If currentF && (followerg == 2 || currentF.GetLeveledActorBase().GetSex() == followerg)
						If CompanionRaces.Find(currentF.GetRace()) > -1 && !currentF.IsDead()
							; If we are configured to apply DD at beginning of scene, do it now for companion
							If (AFV_Global_Restraints.GetValue() == 0)
								applyRestraints(currentF, Ags_Valid[FirstNPC])
							EndIf
			
							AFVTrace(DebugOn,"AFV report: trying to find rapist for companion")
							bCompanionInterrupt = false
							FindRapistFor(currentF)
						EndIf
					EndIf
				EndIf
			EndIf

			currentE += 1
			Utility.Wait(0.1)

		EndWhile

		If interrupted == 1
			bCompanionInterrupt = true
		EndIf
	
	Else
		bCompanionInterrupt = true
	EndIf

	If bPlayerInterrupt &&  bCompanionInterrupt
		;rapists not found for player and companions
		AFVTrace(DebugOn,"AFV report: real interrupt came")
		interrupted = 1
	Else
		AFVTrace(DebugOn,"AFV report: zeroed interrupt")
		AFVTrace(DebugOn,"AFV report: bPlayerInterrupt is " + bPlayerInterrupt)
		AFVTrace(DebugOn,"AFV report: bCompanionInterrupt is " + bCompanionInterrupt)
		interrupted = 0
	EndIf

	CheckForRapeEnd()

EndFunction

Function RegisterEnemies()
	Actor[] AllTargets = PlayerRef.GetAllCombatTargets()

	Int currentE = 0
	Int gendercheck = AFV_Global_Gender_A.GetValueInt()

	While currentE < AllTargets.length
		If (gendercheck == 2 || (AllTargets[currentE].GetLeveledActorBase().GetSex() == gendercheck)) && (AllowedRaces.Find(AllTargets[currentE].getRace()) > - 1)
			RegisterForHitEvent(AllTargets[currentE])
		EndIf
		Utility.wait(0.1)
		currentE += 1
	EndWhile
EndFunction

Event OnAliasInit()
	Debug.Trace("AFV Report: FPV_OnHit OnAliasInit")
	CheckUpdate()
EndEvent

Event OnPlayerLoadGame()
	Debug.Trace("AFV Report: FPV_OnHit OnPlayerLoadGame")
	CheckUpdate()
EndEvent

Event OnGetUp(ObjectReference akFurniture)
	If (surrenderActive)
		AFVTrace(DebugOn,"AFV Report: OnGetUp " + akFurniture)
		PlayerRef.ChangeAnimArchetype()
		PlayerRef.ChangeAnimFlavor()
		PlayerRef.ChangeAnimFlavor(AnimFlavorHandsUp)
	EndIf
EndEvent

Event onTimer(Int aiTimerID)
	If aiTimerID == WeaponTimer
		SheatheWeapon(PlayerRef)
	ElseIf aiTimerID == ResetTimer
		AFVTrace(DebugOn,"AFV report: start to restore NPC and resuming combat")
		UnregisterForAllHitEvents()
		RegisterForHitEvent(PlayerRef)
		
		UnregisterForMenuOpenCloseEvent("PipboyMenu")
		If (UseGodMode)
			PlayerRef.SetGhost(false)
		EndIf

		If (AAF_API.GetVersion() > 68)
			UnregisterForCustomEvent(AAF_API, "OnSceneEnd")
		Else
			UnregisterForCustomEvent(AAF_API, "OnAnimationStop")
		EndIf
		If (ShowUI)
			UnregisterForCustomEvent(AAF_API, "OnAnimationStart")
		EndIf

		SendCustomEvent("Vin_Event_Resume")
		interrupted = 0
		
		Game.SetGameSettingFloat("fEssentialDeathTime", fEssentialDeathTimeSaved)

		Int index = 0
		While (index < FollowerCount)
			Actor tActor = Followers.GetAt(index) as Actor
			If (tActor)
				AFVTrace(DebugOn,"AFV report: reset " + tActor.GetLeveledActorBase().GetName() )
				SetActorExpression(tActor)
				returnToPowerArmor(tActor)
				tActor.RemoveFromFaction(SexFaction)
				tActor.ModValue(AFV_TimesViolated,1)
				ResetAV(tActor,AFV_TimesViolatedCurrentScene)
				ResetAV(tActor, AFV_Gangbanged)
				If (RH_NoPackage)
					tActor.RemoveKeyword(RH_NoPackage)
				EndIf
				tActor.SetNoBleedoutRecovery(SavedNoBleedoutRecovery[index])
			EndIf
			index += 1
		EndWhile
		
		;restore other NPC
		FPV_Follower.Stop()
		FPV_Aggressor.Stop()		
		FPV_Spectator.Stop()
		FPV_Approach.Stop()
		FPV_EnemyScan.Stop()

		index = 0
		While index <= maxRapistE
			AFVTrace(DebugOn,"AFV report: reset " + Ags_Valid[index].GetLeveledActorBase().GetName() )
			returnToPowerArmor(Ags_Valid[index])
			Ags_Valid[index].ModValue(AFV_TimesParticipated,1)
			ResetAV(Ags_Valid[index], AFV_TimesParticipatedCurrentScene)
			Ags_Valid[index].RemoveFromFaction(SexFaction)
			Ags_Valid[index].EvaluatePackage()
			index +=1
		EndWhile

		PlayerRef.RemoveFromFaction(SexFaction)
		SetActorExpression(PlayerRef)
		PlayerRef.ModValue(AFV_TimesViolated,1)
		ResetAV(PlayerRef,AFV_TimesViolatedCurrentScene)
		ResetAV(PlayerRef, AFV_Gangbanged)
		ResetAV(PlayerRef, AFV_NumberOfAggressors)
	EndIf
EndEvent

Event OnKill(Actor akVictim)
	If (FPA_Value_Selfesteem != None && akVictim.GetValue(AFV_TimesParticipated) > 0.0)
		AFVTrace(DebugOn,"AFV Report: Player killed a rapist!")
		var[] seVar = new var[1]
		
		seVar[0] = FPA_Setting_SelfEsteemBaseRape.GetValue() * AFV_Global_SelfEsteemRecovery.GetValue() * 0.01
		FPA_script.CallFunction("ModifySelfEsteem", seVar)
		
		ResetAV(akVictim, AFV_TimesParticipated)
	EndIf
EndEvent

Event OnCombatStateChanged(Actor akTarget, Int aeCombatState)
	bottom = AFV_Global_Health.GetValue() * 0.01
	bottomA = AFV_Global_Health_A.GetValue() * 0.01
	UseGodMode = (AFV_Global_Essential.GetValue() == 1.0)
	DebugOn = (AFV_Global_Debug.GetValue() == 1.0)
	If aeCombatState == 1 && AFV_Global_On.getValue() == 1
		currentS = 0
		FPV_Aggressor.Stop()
		FPV_Aggressor.Start()
		FPV_Follower0.Stop()
		FPV_Follower0.Start()
		While AFV_Global_Chance_A.getValue() > 0 && PlayerRef.IsInCombat()
			RegisterEnemies()
			Utility.Wait(5.0)
		EndWhile
	EndIf
EndEvent

Event OnHit(ObjectReference akTarget, ObjectReference akAggressor, Form akSource, Projectile akProjectile, Bool abPowerAttack, \
  Bool abSneakAttack, Bool abBashAttack, Bool abHitBlocked, string apMaterial)
	Actor akActor = akTarget as Actor
	If (akSource as spell) == None
		If (surrenderActive)
			If (akAggressor != None) && akActor.GetFactionRank(sexFaction) >= 0
				AFVTrace(DebugOn,"AFV Report: onHit actor " + akActor.GetLeveledActorBase().GetName() + " during surrender, interrupting")
				AFVNotify(true,"My aggressors are being attacked!")
				combatInterrupt = true
				interrupted = 1
			Else
				RegisterForHitEvent(akActor)
			EndIf
		Else
			If akActor == PlayerRef
				If AFV_Global_On.getValue() == 1 && PlayerRef.GetValuePercentage(HealthAV) < bottom && Utility.RandomInt(0,99) < AFV_Global_Chance.getValueInt()
					CheckRace(false)
				Else
					RegisterForHitEvent(akActor)
				EndIf
			Else
				If AFV_Global_On.getValue() == 1 && CompanionRaces.Find(akActor.GetRace()) > -1 && akActor.GetValuePercentage(HealthAV) < bottomA && Utility.RandomInt(0,99) < AFV_Global_Chance_A.getValueInt()
					If (akActor.GetLeveledActorBase().isUnique() == False || AFV_Global_Unique_A.GetValueInt() == 1)
						If akActor.IsInPowerArmor()
							exitPowerArmor(akActor)
						EndIf
				
						Victims[currentS].ForceREFto(akActor)
						If currentS == 2
							currentS = 0
						Else
							currentS += 1
						EndIf
						akActor.SetValue(HealthAV, 10)
					EndIf
					; If target is unique and unique actor surrender is off, we don't need to re-register for onhit for this target
				Else
					RegisterForHitEvent(akActor)
				EndIf
			EndIf
		EndIf
	Else
		RegisterForHitEvent(akActor, akSourceFilter = akSource, abMatch = false)
	EndIf
EndEvent

Event OnCripple(ActorValue akActorValue, Bool abCrippled)
	If abCrippled == True && surrenderActive == False && AFV_Global_On.getValue() == 1 && AFV_Global_Cripple.getValue() == 1 \
	&& PlayerRef.IsInCombat() == True && PlayerRef.IsInPowerArmor() == False && Utility.RandomInt(0,99) < AFV_Global_Chance.getValueInt()
		CheckRace(false)
	EndIf
EndEvent

Event OnMenuOpenCloseEvent(string asMenuName, bool abOpening)
    If (asMenuName == "PipboyMenu")
		AFVTrace(DebugOn,"AFV report: Pip-Boy opened")
		startTimer(0,ResetTimer)
	EndIf
EndEvent

Function ForceSurrender()
	AFVTrace(DebugOn,"AFV report: force surrender. AFV_Global_On " + AFV_Global_On.getValue() + " surrenderActive " + surrenderActive)

	If AFV_Global_On.getValue() == 1 && surrenderActive == false
		CheckRace(true)
	EndIf
EndFunction

Function ForceOutcome()
	AFVTrace(DebugOn,"AFV report: force outcome.")
	AFVNotify(True,"Violation scene aborted")
	primaryOutcome = true
	interrupted = 1
	AFV_IsMajorFunctionActive.SetValue(0)
	Outcome(0)
EndFunction

Event AAF:AAF_API.OnAAFReady(AAF:AAF_API akSender, Var[] akArgs)
	AFVTrace(DebugOn,"AFV report: AAF Ready Event")
EndEvent

Bool Function CheckMeta(Var akArg) Global
	String meta = akArg as String
	If (meta)
		String[] metaKeywords = LL_FourPlay.StringSplit(theString = meta, delimiter = ",")
		Return (metaKeywords.Find("AAF_Violate") > -1)
	Endif
	Return False
EndFunction

Event AAF:AAF_API.OnSceneInit(AAF:AAF_API akSender, Var[] akArgs)	
	Int iResult =  akArgs[0] as Int
	If iResult > 0 && checkMeta(akArgs[3])
		AFVTrace(DebugOn,"AFV report: OnSceneInit Event: animation failed to start, result [" + iResult + "]")
		AFVNotify(True, "AAF OnSceneInit status [" + iResult + "]")
		
		; Only abort if there is potential to lock up the scene.  Otherwise just take the first actor out of circulation
		Actor[] actors = Utility.VarToVarArray(akArgs[2]) as Actor[]
		AFVTrace(DebugOn,"AFV report: actors array is " + actors)
		If actors == None || actors.length == 0 || actors.find(PlayerRef) > -1 || AFV_Global_PlayerAffected.getValue() == 0
			ForceOutcome()
		Else
			int index = 0
			While index < actors.length
				If (actors[index].GetFactionRank(sexFaction) >= 0)
					actors[index].removeFromFaction(sexFaction)
					actors[index].EvaluatePackage()
				Endif
				index += 1
			EndWhile
		EndIf
	ElseIf checkMeta(akArgs[5])
		AFVTrace(DebugOn,"AFV report: SceneInit Event")
		If (akArgs[2] as Actor)
			SetActorExpression(akArgs[2] as Actor, 2)
		EndIf
			
		; support for Synth Clamp-Ons			
		If (Game.IsPluginInstalled("0SynthClamp-Ons.esp"))
			Actor[] actors = Utility.VarToVarArray(akArgs[1]) as Actor[]
			Keyword actorTypeSynth = Game.GetFormFromFile(0x0010C3CE, "Fallout4.esm") as Keyword
			Leveleditem leveledDong = Game.GetFormFromFile(0x000035D9, "0SynthClamp-Ons.esp") as Leveleditem
			
			Int idx = 0
			While(idx < actors.length)
				If (actors[idx].hasKeyword(actorTypeSynth))
					AFVTrace(DebugOn,"AFV Report: Actor " + idx + " is a Synth")
					ObjectReference dongRef = actors[idx].placeAtMe(leveledDong)
					actors[idx].additem(dongRef)
					actors[idx].equipitem(dongRef.GetBaseObject())
					;AAF_API.ApplyEquipmentSet(actors[idx], "addSynthDildos")
				EndIf
				idx += 1
			EndWhile		
		EndIf
	EndIf
EndEvent

Event AAF:AAF_API.OnAnimationStart(AAF:AAF_API akSender, Var[] akArgs)
	If checkMeta(akArgs[4])
		AFVTrace(DebugOn,"AFV report: AnimationStart Event")
		Actor[] actors = Utility.VarToVarArray(akArgs[1]) as Actor[]
		If Actors.Find(PlayerRef) > -1
			MyLayer.EnablePlayerControls()
		EndIf
	EndIf
EndEvent

Event AAF:AAF_API.OnAnimationStop(AAF:AAF_API akSender, Var[] akArgs)
	Int iResult =  akArgs[0] as Int
	If iResult > 0
		AFVTrace(DebugOn,"AFV report: OnAnimationStop: error [" + iResult + "]")
		AFVNotify(True, "AAF OnAnimationStop status [" + iResult + "]")
		ForceOutcome()
	ElseIf checkMeta(akArgs[4])
		AFVTrace(DebugOn,"AFV report: AnimationStop Event")
		Actor[] actors = Utility.VarToVarArray(akArgs[1]) as Actor[]
		AnimationEnd(actors)
	EndIf
EndEvent

Event AAF:AAF_API.OnSceneEnd(AAF:AAF_API akSender, Var[] akArgs)
	Int iResult =  akArgs[0] as Int
	If iResult > 0
		AFVTrace(DebugOn,"AFV report: OnSceneEnd: error [" + iResult + "]")
		AFVNotify(True, "AAF OnSceneEnd status [" + iResult + "]")
		ForceOutcome()
	ElseIf checkMeta(akArgs[4])
		AFVTrace(DebugOn,"AFV report: OnSceneEnd Event")
		Actor[] actors = Utility.VarToVarArray(akArgs[1]) as Actor[]
		AnimationEnd(actors)
	EndIf
EndEvent

Function AnimationEnd(Actor[] actors)
	Int index = 0
	Int victim = -1
	Int found = 0

	AFVTrace(DebugOn,"AFV report: AnimationEnd actors.length " + actors.length + " max rounds " + ExRounds + " cur round " + curRounds)

	If actors.length > 0
		While (index < actors.length)
			If (actors[index].GetFactionRank(sexFaction) >= 0)
				actors[index].removeFromFaction(sexFaction)
				Utility.wait(0.1)
				actors[index].EvaluatePackage()
				If (Ags_Valid.Find(actors[index]) > -1)
					AFVTrace(DebugOn,"AFV report: AnimationEnd actors[" + index + "] " + actors[index].GetLeveledActorBase().GetName() + " is aggressor")
					actors[index].ModValue(AFV_TimesParticipatedCurrentScene, 1)
				ElseIf (actors[index] == PlayerRef)
					AFVTrace(DebugOn,"AFV report: AnimationEnd actors[" + index + "] " + actors[index].GetLeveledActorBase().GetName() + " is player")
					If (ShowUI)
						MyLayer.DisablePlayerControls()
					EndIf
					SetActorExpression(actors[index],1)
					PlayerRef.ModValue(AFV_TimesViolatedCurrentScene, 1)
					curRounds += 1
					victim = index
				Else
					AFVTrace(DebugOn,"AFV report: AnimationEnd actors[" + index + "] " + actors[index].GetLeveledActorBase().GetName() + " is companion")
					SetActorExpression(actors[index],1)
					actors[index].ModValue(AFV_TimesViolatedCurrentScene, 1)
					If (AFV_Global_PlayerAffected.getValue() == 0)
						curRounds += 1
					EndIf
					victim = index
				EndIf
			Else
				AFVTrace(DebugOn,"AFV report: AnimationEnd actors[" + index + "] " + actors[index].GetLeveledActorBase().GetName() + " is not in sex faction!")
			EndIf
			index += 1
		EndWhile
						
		AFVTrace(DebugOn,"AFV report: cur round is " + curRounds + " max rounds are " + exRounds);

		If (curRounds >= exRounds)
			interrupted = 1
		ElseIf (victim > -1)
			; If we don't have enough rapists for all our victims, give the waiting victim a chance at a round
			If (victimWaiting)
				Utility.Wait(2.0)
			EndIf
			found = FindRapistFor(actors[victim])
		Else
			AFVTrace(DebugOn,"AFV report: AnimationEnd victim not found")
			interrupted = 1
		EndIf
	Else
		AFVTrace(DebugOn,"AFV report: AnimationEnd Function has no valid actors")
		interrupted = 1
	EndIf
	
	; If this is the last round for this victim and we are configured to apply DD at end of scene
	If (victim > -1) && (found == -1 || interrupted == 1)
		If (AFV_Global_Restraints.GetValue() == 1)
			applyRestraints(actors[victim], Ags_Valid[FirstNPC])
		EndIf
	EndIf

	AFVTrace(DebugOn,"AFV report: AnimationEnd, interrupted is " + interrupted)
	If interrupted == 1
		CheckForRapeEnd()
	EndIf
EndFunction

Function CheckForRapeEnd()
	AFVTrace(DebugOn,"AFV report: CheckForRapeEnd start, interrupted is " + interrupted)
	
	If interrupted == 1
		; ensure we only run once.  With combat interrupts it is possible to get multiple calls here
		If primaryOutcome == false
			primaryOutcome = true
			
			While IsAnimRunning()
				Utility.wait(1.0)
			EndWhile

			AFVTrace(DebugOn,"AFV report: outcome player")

			AFV_IsMajorFunctionActive.SetValue(0)
			AFVTrace(DebugOn,"AFV report: setting major Function OFF from CheckForRapeEnd Function")

			Outcome(1)
		Else
			AFVTrace(DebugOn,"AFV report: CheckForRapeEnd already running")
		EndIf
	EndIf
EndFunction

Event OnPlayerTeleport()
	location CurrentLocation = PlayerRef.GetCurrentLocation()
	If CurrentLocation != savedLocation
		AFVTrace(DebugOn,"AFV report: location loaded after teleport")

		FPV_Follower.Stop()
      	FPV_Aggressor.Stop()		
		FPV_Spectator.Stop()
		FPV_Approach.Stop()
		Utility.wait(1.0)
		
		Actor[] playerFollowers = Game.GetPlayerFollowers()
		AFVTrace(DebugOn,"AFV report: playerFollowers.Length is " + playerFollowers.Length)

		Int index = 0
		While (index < playerFollowers.Length)
			playerFollowers[index].moveTo(PlayerRef)
			playerFollowers[index].PlayIdle(IdleStop)

			AFVTrace(DebugOn,"AFV report: follower with id " + index + " teleported to player location")
			index += 1
		EndWhile
	EndIf

	UnregisterForPlayerTeleport()
EndEvent

Function SheatheWeapon(Actor akActor)
	If akActor.IsWeaponDrawn() == True
		akActor.PlayIdle(RaiderSheath)
		Weapon equippedWeapon = akActor.GetEquippedWeapon()
		If (equippedWeapon)
			akActor.UnequipItem(equippedWeapon)
		EndIf
	EndIf
EndFunction

Function SetActorExpression(actor akActor, Int iAction=0)
	Keyword AFArchetype
	Int dieRoll = Utility.RandomInt(0,3)
	
	If (iAction == 0) ; reset
		AFArchetype = none
	ElseIf (iAction == 1) ; normal surrendered
		If (Submission > 1 && akActor == PlayerRef)
			AFArchetype = FPV_AFA_SurrenderP[dieRoll]
		Else
			AFArchetype = FPV_AFA_SurrenderN[dieRoll]
		EndIf
	Else ; in animation
		If (Submission > 1 && akActor == PlayerRef)
			AFArchetype = FPV_AFA_AnimP[dieRoll]
		Else
			AFArchetype = FPV_AFA_AnimN[dieRoll]
		EndIf
	EndIf

	;AFVTrace(DebugOn,"AFV report: set " + akActor.GetLeveledActorBase().GetName() + " faceAnim to " + AFArchetype)
	akActor.ChangeAnimFaceArchetype(AFArchetype)
EndFunction

Bool Function IsAnimRunning()
	If (PlayerRef.HasKeyword(AAF_ActorBusy))
		AFVTrace(DebugOn,"AFV report: IsAnimRunning: " + PlayerRef.GetLeveledActorBase().GetName() + " is busy")
		return true
	Else
		Int index = 0
		While (index < FollowerCount)
			Actor currentF = Followers.GetAt(index) as Actor
			If (currentF) && currentF.HasKeyword(AAF_ActorBusy)
				AFVTrace(DebugOn,"AFV report: IsAnimRunning: " + currentF.GetLeveledActorBase().GetName() + " is busy")
				return true
			EndIf
			index += 1
		EndWhile
	EndIf
	
	AFVTrace(DebugOn,"AFV report: IsAnimRunning: no actors are busy")
	return false
EndFunction

Function exitPowerArmor(Actor targetActor)
	Int tries=0
	targetActor.SwitchToPowerArmor(None)
	While targetActor.IsInPowerArmor() && tries < 50
		Utility.Wait(0.1)
		tries += 1
	EndWhile
	AFVTrace(DebugOn,"AFV report: exitPowerArmor returns after " + tries + " tries")
EndFunction

Function returnToPowerArmor(Actor targetActor)
	ObjectReference powerArmor = targetActor.GetLinkedRef(LinkPowerArmor)
	If (powerArmor)
		targetActor.SwitchToPowerArmor(powerArmor)
	EndIf
EndFunction

Function RestoreActorLimbs(Actor akActor)
	akActor.RestoreValue(PerceptionCondition, 100)
	akActor.RestoreValue(LeftAttackCondition, 100)
	akActor.RestoreValue(RightAttackCondition, 100)
	akActor.RestoreValue(EnduranceCondition, 100)
	akActor.RestoreValue(RightMobilityCondition, 100)
	akActor.RestoreValue(LeftMobilityCondition, 100)
EndFunction

Function ResetAV(Actor akActor, ActorValue akActorValue)
	Float amt = akActor.GetValue(akActorValue)
	If (amt > 0.0)
		amt = amt * -1.0
		akActor.ModValue(akActorValue, amt)
	EndIf
EndFunction

