Scriptname FPV_DDManagerProxyScript extends Quest

ScriptObject RoggDDManager
Import FPV_Logger

; As of Violate 1.20 this is obsolete and no longer called by any other scripts
; Rogg DD Items Manager 1.0.3 introduced a CallFunction() compatible version of his
; PickRandomItems() call which makes this proxy unnecessary

Function LoadRDDM()
	If Game.IsPluginInstalled("Rogg DD Items Manager.esp")
		RoggDDManager = Game.GetFormFromFile(0x00004c50, "Rogg DD Items Manager.esp") as Quest
		AFVTrace(true,"AFV report: FPV_DDManagerProxyScript: Rogg DD Manager is installed")
	Else
		AFVTrace(true,"AFV report: FPV_DDManagerProxyScript: Rogg DD Manager not found")
	EndIf
EndFunction

Var Function PickRandomDDItems()
	form[] _forms = (RoggDDManager as Rogg:DDManager).PickRandomItems()
	return Utility.VarArrayToVar(_forms as Var[])
EndFunction
