Scriptname FPV_FightBack extends RefCollectionAlias

Import FPV_Logger

Actor Property PlayerRef Auto Const Mandatory
GlobalVariable Property AFV_Global_Debug Auto Const Mandatory
Keyword Property ObjectTypeWeapon Auto Const Mandatory
Keyword Property WeaponTypeUnarmed Auto Const Mandatory
ReferenceAlias Property PlayerAlias Auto Const Mandatory

FPV_OnHit FPV_Script

Event OnAliasInit()
	RegisterForHitEvent(Self, PlayerRef, ObjectTypeWeapon)
	RegisterForHitEvent(Self, PlayerRef, WeaponTypeUnarmed)
	FPV_Script = PlayerAlias as FPV_OnHit
EndEvent

Event OnHit(ObjectReference akTarget, ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, \
  bool abSneakAttack, bool abBashAttack, bool abHitBlocked, string apMaterial)

	AFVTrace(True, "AFV Report: FPV_FightBack - OnHit on " + akTarget + " by " + akAggressor + " with " + akSource + " from " + LL_FourPlay.OriginalPluginName(akSource))
	FPV_Script.interrupt()
EndEvent
